<?

class CDEDeserializer{

	function CDEDeserializer(){
		$this->vn = 'v';
		$this->mapper = null;
		$this->oldPHPVersion = false;
	}

	function setCharMapper($cm){
		$this->mapper = $cm;
	}
	

	function deserialize($ds){
		$this->dataSource = $ds;
		$this->pointer = 0;
		//$this->vn = $this->dataSource['__CompactDataExchangeVariableName'];
		$this->variableCount = $this->dataSource['__CompactDataExchangeVariableCount'];
		$this->objectStack = array();
		
		$ret = array();
		$this->currentDataObject = &$ret;
		$this->currentDataKey = '';
		
	
		$this->initCurrentPointerData();
		while ($this->process){
			$this->currentDataKey = $this->currentData;
			$this->stepToNextTag();
			$this->initCurrentPointerData();
			$this->deserializeCurrentData();
			$this->stepToNextTag();
			$this->initCurrentPointerData();
		}

		return $ret;			
	}
		
		
	function initCurrentPointerData(){
		$varname = $this->vn.$this->pointer;
		if (isset($this->dataSource[$varname])){
			$this->currentData = $this->dataSource[$varname];
		}
		else{
			$this->currentData = null;
		}
		//$this->process = ($this->currentData !== null);
		$this->process = $this->pointer < $this->variableCount;
	}
	
	function stepToNextTag(){
		$this->pointer ++;
	}

	function deserializeCurrentData(){
		$varType = substr($this->currentData,0,1);
		$f = 'deserializeDataType_'.$varType;
		if ($this->oldPHPVersion){
			$this->$f();
			// call_user_method ( $f, $this);
			// not good, because in PHP4.0.) will pass by value
		}
		else{
			call_user_func( array(&$this,$f),array());
		}
	}	
	
	function deserializeDataType_S(){
		$value = substr($this->currentData,1);
		if ($this->mapper !== null){
			$value = $this->mapper->decodeString($value);
		}
		$this->currentDataObject[$this->currentDataKey] = $value;
	}		

	function deserializeDataType_N(){
		$this->currentDataObject[$this->currentDataKey] = (real)(substr($this->currentData,1));
	}

	function deserializeDataType_B(){
		$this->currentDataObject[$this->currentDataKey] = (boolean)(substr($this->currentData,1,1) == 'T');
	}

	function deserializeDataType_M(){
		$this->deserializeDataType_H();
	}
	
	function deserializeDataType_H(){
		$this->currentDataObject[$this->currentDataKey] = array();
		$this->pushCurrentDataPointer();
		$this->stepToNextTag();
		$this->initCurrentPointerData();
		$l = (integer)($this->currentData);
		for($i=0;$i<$l;$i++){
			$this->stepToNextTag();
			$this->initCurrentPointerData();
			$this->currentDataKey = $this->currentData;
			$this->stepToNextTag();
			$this->initCurrentPointerData();
			$this->deserializeCurrentData();
		}
		$this->popCurrentDataPointer();
	}
	
	function deserializeDataType_F(){
		$this->currentDataObject[$this->currentDataKey] = null;
	}
	
	function deserializeDataType_X(){
		$this->currentDataObject[$this->currentDataKey] = null;
	}
	
	
	function pushCurrentDataPointer(){
		$this->objectStack[count($this->objectStack)] = &$this->currentDataObject;
		$this->currentDataObject = &$this->currentDataObject[$this->currentDataKey];
	}
	
	function popCurrentDataPointer(){
		$l = count($this->objectStack) - 1;
		$this->currentDataObject = &$this->objectStack[$l];
		unset($this->objectStack[$l]);
	}
	
}

?>