<?
	class CDESerializer{

		function CDESerializer(){
			$this->pointer = 0;
			$this->data = array();
			$this->varName = 'v';
			$this->mapper = null;
			$this->fastSerialization = false;
			$this->responseStripCR = false;
			$this->oldPHPVersion = false;
		}
		
		function setCharMapper($cm){
			$this->mapper = $cm;
		}
		
		function setResponseStripCR($b){
			$this->responseStripCR = $b;
		}
		

		function setFastSerialization($b){
			$this->fastSerialization = $b;;
		}
		
		
		function addVariable(&$var,$varname){
			$this->serializeVar(&$var,$varname);
			
		}
		

		function serialize(){
			return $this->getStringRepresentation();
		}
		
		function getStringRepresentation(){
			$ret = '';
			$l = count($this->data);
			//$ret = '&__CompactDataExchangeVariableName='.$this->varName."&\n";
			$ret .= '&__CompactDataExchangeVariableCount='.$l."&";
			for($i=0;$i<$l;$i++){
				if (!$this->fastSerialization){
					$ret .= '&'.$this->varName.$i.'='.rawurlencode($this->data[$i])."&";
				}
				else{
					$enc = str_replace('%','%25',$this->data[$i]);
					$enc = str_replace('&','%26',$enc);
					$ret .= '&'.$this->varName.$i.'='.$enc."&";
				}
				
				//$ret .= '&'.$this->varName.$i.'='.$this->data[$i]."&";
				//$ret .= '&'.$this->varName.$i.'='.rawurlencode($this->data[$i])."&";
				//$ret .= '&'.$this->varName.$i.'='.rawurlencode($this->data[$i]);
			}
			$len = strlen($ret);
			$ret .= "&__CompactDataExchangePacketSize=$len&";
			$ret .= "&__CompactDataExchangePacketEnd=true&";
			return $ret;
		}
		
		
		function serializeVar(&$var,$varname){
			$type = gettype($var);
			if ($type == 'integer' || $type == 'double'){
				$type = 'number';
			}
			if ($type == 'array'){
				$type = 'arraystructchooser';
			}
			if ($this->oldPHPVersion){
				$this->{'serializeDataType_'.$type}(&$var,$varname);
			}
			else{
				call_user_func(array(&$this,'serializeDataType_'.$type),&$var,$varname);
			}
			
		}
		
		
		function serializeDataType_boolean(&$var,$varname){
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('B'.($var?'T':'F'));
		}

		function serializeDataType_number(&$var,$varname){
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('N'.$var);
		}
		
		function serializeDataType_string(&$var,$varname){
			if ($varname !== null){
				$this->addData($varname);
			}
			$value = $var;
			if ($this->responseStripCR){
				$value = str_replace("\r",'',$value);
			}
			
			if ($this->mapper !== null){
				$value = $this->mapper->encodeString($value);
			}
			
			$this->addData('S'.$value);
		}

		function serializeDataType_arraystructchooser(&$var,$varname){
			$l = count($var);
			$i = 0;
			$indexed = true;
			while($indexed && $i < $l){
				if (!isset($var[$i])){
					$indexed = false;
				}
				$i++;
			}
			if ($indexed){
				if ($this->isRecordSet(&$var)){
					$this->serializeDataType_recordset(&$var,$varname);
				}
				else{
					$this->serializeDataType_array(&$var,$varname);
				}
			}
			else{
				$this->serializeDataType_struct(&$var,$varname);
			}
		}
		
		function serializeDataType_array(&$var,$varname){
			$l = count($var);
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('A');
			$this->addData($l);
			for($i=0;$i<$l;$i++){
				$this->serializeVar(&$var[$i],null);
			}
		}

		function serializeDataType_object(&$var,$varname){
			if (get_class ($var) == 'cabronrecordset' && isset($var->items)){
				$this->serializeDataType_recordset(&$var->items,$varname);
			}
			else{
				$this->serializeDataType_NULL(&$var,$varname);
			}
		}

		function serializeDataType_struct(&$var,$varname){
			$l = count($var);
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('H');
			$this->addData($l);
			foreach($var as $key => $value){
				$this->serializeVar($value,$key);
			}
		}

		function serializeDataType_recordset(&$var,$varname){
			$l = count($var);
			$fields = array();
			if ($l !== 0){
				$fields = array_keys($var[0]);
				$f = count($fields);
			}
			else{
				$f = 0;
			}
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('R');
			// rows
			$this->addData($l);
			// columns - fields
			$this->addData($f);
			// column list
			for($c=0;$c<$f;$c++){
				$this->addData($fields[$c]);
			}
			// data
			for($r=0;$r<$l;$r++){
				for($c=0;$c<$f;$c++){
					$this->serializeVar(&$var[$r][$fields[$c]],null);
				}
			}
		}
		
		function serializeDataType_NULL(&$var,$varname){
			if ($varname !== null){
				$this->addData($varname);
			}
			$this->addData('X');
		}
		

		function addData($v){
			$this->data[] = $v;
		}
		
		function isRecordset(&$v){
			$ret = true;
			// not empty and 0 row defined and isarray
			if (count($v) !== 0 && isset($v[0]) && gettype($v[0]) == 'array'){
				$keys = array_keys($v[0]);
				$keynr = count($keys);
				for($i=0;$i<$keynr;$i++){
					if (gettype($keys[$i]) != 'string'){
						$ret = false;
					}
				}
				
				$l = count($v);
				for($r=1;$r<$l;$r++){
					if (isset($v[$r])){
						if (count($v[$r]) == $keynr){
							for($c=0;$c<$keynr;$c++){
								if (!isset($v[$r][$keys[$c]])){
									$ret = false;
								}
							}
						}
						else{
							$ret = false;
						}
					}
					else{
						$ret = false;
					}
				}
			}
			else{
				$ret = false;
			}
			//return false;
			return $ret;
		}
		
	
	}
	
?>