<?
/* Cabron Connector PHP Flash Remoting for Flash MX
 * Copyright 2003 Attila Egyedi <eatti@angelfire.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 


/*
Cabron Connector
------------------------------------------------------------------------------
	Created by 
		Attila Egyedi
		eatti@angelfire.com
	Check for new releases at
		http://cabron.sourceforge.net
 
Revision History:
--------------------------------------------
v 0.1.0 - first release

v 1.1.0 - it will work with PHP 4.0.5 and above

-----------------------------------------------------------------------------*/


	include_once('./lib/helpers.php');
	include_once('./lib/CDEDeserializer.php');
	include_once('./lib/CDESerializer.php');
	include_once('./lib/CabronResponseCharConverter.php');
	include_once('./lib/CabronResponseCharMapper.php');
	include_once('./lib/CabronRequestCharConverter.php');
	include_once('./lib/CabronRequestCharMapper.php');
	include_once('./lib/CabronRecordSet.php');

class CabronGateway{

	function CabronGateway(){
		startTimer();
		reportTime("start");
		$this->serviceBaseFolder = '.';
		$this->receivedData = array();
		$this->result = null;
		$this->errmsg = '';					// full error message
		$this->response = '';
		$this->responseCharConverterName = '';
		$this->requestCharConverterName = '';
		$this->responseStripCR = false;
		$this->fastSerialization = false;
		$this->profileReport = false;
		$this->errorCode = null;			// error code
		$this->errorDescription = null;		//simple error message
		$this->innerErrorMessages = array(
			2	=>	'Service not found',
			3	=>	'Remote method not defined',
			4	=>	'Empty request',
			6	=>	'Can not locate charactermap'
		);
		header ('Content-Type:text/html; charset=UTF-8');
		
		// analyze the current version, to know
		// how to call user methods on objects.
		$currentPHPVersion = (integer)(str_replace ('.', '', phpversion()));
		$limitVersion = 410;
		$this->oldPHPVersion = ($currentPHPVersion < $limitVersion);

	}
	
	function setProfileReport($b){
		$this->profileReport = $b;
	}
	
	
	function setResponseStripCR($b){
		$this->responseStripCR = $b;
	}
	
	
	function setFastSerialization($b){
		$this->fastSerialization = $b;
	}


	function addInnerError($errmsg,$errorCode,$errorDescription = ''){
		if ($this->errorCode === null){
			$this->errorCode = $errorCode;
			if (isset($this->innerErrorMessages[$errorCode])){
				$this->errorDescription = $this->innerErrorMessages[$errorCode];
			}
			else{
				$this->errorDescription = $errorDescription;
			}
			$this->errmsg .= $errmsg;
		}
	}
	
	
	
	function setServiceBaseFolder($sbf){
		global $CabronServiceBaseFolder;
		$this->serviceBaseFolder = $sbf;
		$CabronServiceBaseFolder = $sbf; // for script includes
	}
	
	function getPostedData(){
		$this->receivedData = getParameter(null,'POST');
		if (get_magic_quotes_gpc() == 1){
			foreach($this->receivedData as $k => $v){
				$this->receivedData[$k] = stripslashes($v);
			}
		}
		//print_r($this->receivedData);
	}

	function inspectClassOrFunction(){
		// null  - error
		// true  - class
		// false - function
		
		$this->className = ucfirst($this->serviceName);
		$pos = strrpos($this->className, '/');
		if ($pos !== false && ($pos+1)<strlen($this->className)){
			$this->className = substr($this->className,$pos+1);
		}
		if (class_exists($this->className)){
			$istr = '$this->serviceObject = new '.$this->className.'();';
			eval($istr);
			// if the method can not be found in the class
			if (!method_exists ( $this->serviceObject, $this->methodName)){
				$errmsg = "Cabron Gateway Error: The requested method (".$this->methodName.") is not defined in the class (".$this->className.") in the file\n\t".$this->fileName."\n";
				$errmsg .= "absolute path:\n\t".cabronAbsolutePathOfFile($this->fileName)."\n";
				$errmsg .= "Method list:";
				$methodList =  get_class_methods($this->className);
				foreach($methodList as $m){
					$errmsg .= "\n\t$m";
				}
				$this->addInnerError($errmsg,3);
				return null;
			}
			else{
				return true;
			}
		}
		// the class does not exists, try to call the function
		else{
			if (function_exists ($this->methodName)){
				return false;
			}
			else{
				$errmsg = "Cabron Gateway Error: The requested function (".$this->methodName.") is not defined in the file\n\t".$this->fileName."\n";
				$errmsg .= "absolute path:\n\t".cabronAbsolutePathOfFile($this->fileName)."\n";
				$this->addInnerError($errmsg,3);

				return null;
			}	
		}
	}
	

	function servicePart1(){
		reportTime("service part1 start");
		global $CabronServiceFolder; // to use from the services
		$ret = true;
		$this->getPostedData();
		if (count($this->receivedData) == 0){
			$errmsg = "The request packet was empty\nPlease check if the POST parameters are received by the gateway script: ";
			$errmsg .= cabronAbsolutePathOfFile($_SERVER['PHP_SELF']);
			$this->addInnerError($errmsg,4);
			$ret = false;
		}
		else{
			$this->serviceName = $this->receivedData['__CabronRequestedServiceName'];
			$this->methodName = $this->receivedData['__CabronRequestedMethodName'];
			$this->serviceName = str_replace ( '.', '/', $this->serviceName);
			$this->fileName = $this->serviceBaseFolder.'/'.$this->serviceName.'.php';
			if (!file_exists($this->fileName)){
				$errmsg = "Cabron Gateway Error: Can not locate the requested service.\n";
				$errmsg .= "relative path (from the gateway.php):\n\t".$this->fileName."\n";
				$errmsg .= "absolute path:\n\t".cabronAbsolutePathOfFile($this->fileName)."\n";
				$errmsg .= "\nPlease check: \n\tthe gateway.php - \$serviceBaseFolder variable\n";
				$errmsg .= "\tCabronConnectorInstance.getService() call\n\n";
				$this->addInnerError($errmsg,2);
				$ret = false;
			}
			$CabronServiceFolder = cabronDirName($this->fileName);
		}
		reportTime("service part1 time");
		return $ret;
	}

	function setRequestedOptions($requestedOptions){
		if (gettype($requestedOptions) == 'array'){
			if (isset($requestedOptions['requestCharMapper']) && $requestedOptions['requestCharMapper'] !== null){
				$this->requestCharConverterName = $requestedOptions['requestCharMapper'];
			}
			if (isset($requestedOptions['responseCharMapper']) && $requestedOptions['responseCharMapper'] !== null){
				$this->responseCharConverterName = $requestedOptions['responseCharMapper'];
			}
			if (isset($requestedOptions['responseStripCR']) && $requestedOptions['responseStripCR'] !== null){
				$this->responseStripCR = $requestedOptions['responseStripCR'];
			}
			if (isset($requestedOptions['fastSerialization']) && $requestedOptions['fastSerialization'] !== null){
				$this->fastSerialization = $requestedOptions['fastSerialization'];
			}
			if (isset($requestedOptions['profileReport']) && $requestedOptions['profileReport'] !== null){
				$this->profileReport = $requestedOptions['profileReport'];
			}
			
		}
	}
	

	
	function performDeserialization(){
		
		
		$optionFunctionName = 'setGatewayOptions';
		$ret = true;
		
		$this->isClass = $this->inspectClassOrFunction();
		// error?
		if ($this->isClass === null){
			$ret = false;
		}
		//class or function
		else{
			// it's function
			if ($this->isClass === false){
				//set the options
				if (function_exists($optionFunctionName)){
					$requestedOptions = call_user_func($optionFunctionName,$this->methodName);
					$this->setRequestedOptions($requestedOptions);
				}
			}
			// it's class
			else{
				if (method_exists($this->serviceObject,$optionFunctionName)){
					if ($this->oldPHPVersion){
						$requestedOptions = call_user_method_array($optionFunctionName, &$this->serviceObject, array($this->methodName));
					}
					else{
						$requestedOptions = call_user_func_array( array(&$this->serviceObject,$optionFunctionName),array($this->methodName));
					}
					$this->setRequestedOptions($requestedOptions);
				}
			}

			$deserializer = new CDEDeserializer();
			$deserializer->oldPHPVersion = $this->oldPHPVersion;
			
			$requestCharMapper = new CabronRequestCharMapper($this->requestCharConverterName);
			$deserializer->setCharMapper($requestCharMapper);
	
			$this->request = $deserializer->deserialize($this->receivedData);
		}
		return $ret;
	}
	
	
	function servicePart2(){
		reportTime("file included. service MAIN part start");
		$methodAvailable = $this->performDeserialization();
		if ($methodAvailable === true){
			$args = $this->request['arguments'];
			ksort($args);
			if ($this->isClass === true){
				if ($this->oldPHPVersion){
					$result = call_user_method_array($this->methodName, &$this->serviceObject, $args);
				}
				else{
					$result = call_user_func_array( array(&$this->serviceObject,$this->methodName),$args);
				}
				return $result;
			}
			// the class does not exists, try to call the function
			else{
				$result = call_user_func_array($this->methodName,$args);
				return $result;
			}
		}
		else{
			return null;
		}
	}	

	function servicePart3($r){
			reportTime("service part3 start");
			$this->result = $r;

			$serializer = new CDESerializer();
			$serializer->oldPHPVersion = $this->oldPHPVersion;

			$serializer->setFastSerialization($this->fastSerialization);

			$responseCharMapper = new CabronResponseCharMapper($this->responseCharConverterName);
			$serializer->setCharMapper($responseCharMapper);

			$serializer->setResponseStripCR($this->responseStripCR);

			$serializer->addVariable($this->result,'result');
			$serializer->addVariable($this->errmsg,'ERRORMESSAGE'); // full message
			$serializer->addVariable($this->errorCode,'ERRORCODE'); // code
			$serializer->addVariable($this->errorDescription,'ERRORDESCRIPTION'); // short message
			$output = ob_get_contents();
			// to make it work with PHP4.0.0
			ob_end_clean();
			ob_start();
			
			// clear the whitespaces before and after the service definition
			$output = trim($output);
			$serializer->addVariable($output,'GATEWAYOUTPUT');
			if ($this->profileReport){
				$p = getProfile();
				$serializer->addVariable($p,'profile');
			}
			reportTime("service part3 almost finished");
			$this->response = $serializer->serialize();
	}
	
	function setResponseCharMapper($s){
		$this->responseCharConverterName = $s;
	}
	
	function setRequestCharMapper($s){
		$this->requestCharConverterName = $s;
	}
	
	
}

?>