<?
	class CabronRequestCharMapper{

		function CabronRequestCharMapper($converterNameList){
			$this->converters = array();
			$converterNameList = trim($converterNameList);
			if ($converterNameList != ''){
				$cnl = explode(',',$converterNameList);
				foreach($cnl as $cn){
					$this->converters[] = new CabronRequestCharConverter($cn);
				}
			}
		}

		function decodeUTF8SeqToChar($seq){
			$unicode = $this->utf8seq2UniPoint($seq);
			//print "uni = $unicode\n";
			if ($unicode == -1){
				return '';
			}
			else{
				list($mapped,$char) = $this->mapUniPoint($unicode);
				if ($mapped){
					return $char;
				}
				else{
					$ret = '';
					for($i=0;$i<count($seq);$i++){
						$ret .= chr($seq[$i]);
					}
					return $ret;
				}
			}
		}
		
		function utf8seq2UniPoint($seq){
			//print_r($seq);
			$u0 = 0x40; //6 bits;
			switch (count($seq)){
				case 0:
						return -1;
						break;
				case 1:
						return $seq[0];
						break;
				case 2:
						return ($seq[0] & 0x1F) * $u0 + ($seq[1] & 0x3F);
						break;
				case 3:
						return ($seq[0] & 0x0F) * $u0 * $u0 + ($seq[1] & 0x3F) * $u0 + ($seq[2] & 0x3F);
						break;
				case 4:
						return ($seq[0] & 0x07) * $u0 * $u0 * $u0 + ($seq[1] & 0x3F) * $u0 * $u0+ ($seq[2] & 0x3F) * $u0 + ($seq[3] & 0x3F);
						break;
				default:
						return 0x20;
			}
		}

		function isSingleChar($c){
			return ($c < 0x80);
		}

		function isStartOfChar($c){
			return (($c & 0xC0) == 0xC0);
		}
	
		// decode UTF-8 string
		function decodeString($s){
			if (count($this->converters) == 0){
				return $s;
			}
			$ret = '';
			$i = 0;
			$l = strlen($s);
			$unicode = -1;
			$seq = array();
			$charID = 0;
			//print "decode $s $l\n";
			while($i < $l){
				$c = $s[$i];
				$o = ord($c);
				if ($this->isSingleChar($o)){
					$ret .= $this->decodeUTF8SeqToChar($seq);
					$seq = array();
					$seq[0] = $o;
				}
				else{
					if ($this->isStartOfChar($o)){
						$ret .= $this->decodeUTF8SeqToChar($seq);
						$seq = array();
						$charID = 0;
						$seq[$charID] = $o;
					}
					else{
						$charID ++;
						$seq[$charID] = $o;
					}
				}
				$i++;
			}
			$ret .= $this->decodeUTF8SeqToChar($seq);
			//print "decoded $ret\n";
			return $ret;
		}
	
		function mapUniPoint($o){
			//print "map $o\n";
			$cc = count($this->converters);
			$cid = 0;
			$mapped = false;
			while($cid < $cc && !$this->converters[$cid]->canConvert($o)){
				$cid++;
			}
			if ($cid < $cc){
				// take the found mapper
				$ret = $this->converters[$cid]->convertUnicode($o);
				$mapped = true;
			}
			else{
				// output as is
				$ret = $o;
			}
			//print "mapped $mapped $ret\n";
			
			return array($mapped,chr($ret));
		}
	}

?>