<pre>
<?

	function unicode2utfsrc($num){
		if($num<128)return "chr(".$num.")";
 		if($num<1024)return "chr(".(($num>>6)+192).").chr(".(($num&63)+128).")";
		if($num<32768)return "chr(".(($num>>12)+224).").chr(".((($num>>6)&63)+128).").chr(".(($num&63)+128).")";
		if($num<2097152)return "chr(".($num>>18+240).").chr(".((($num>>12)&63)+128).").chr(".(($num>>6)&63+128).").chr(".($num&63+128).")";
 		return '';
	}
	
	function extractFileName($f){
		$p = strrpos($f,'.');
		if ($p === false){
			return $p;
		}
		else{
			return substr($f,0,$p);
		}
	}

	function extractFileExtension($f){
		$p = strrpos($f,'.');
		if ($p === false){
			return '';
		}
		else{
			return substr($f,$p+1);
		}
	}
	
	function convertToDecoderClass($fn){
		global $srcDir;
		$ret = '';
		$mapstr = '';
		$lines = file($srcDir.'/'.$fn);
		$forceall = false;
		$map = array();
		foreach($lines as $l){
			$l = trim($l);
			if (strstr($l,'#CABORNFORCE') !== false){
				$forceall = true;
			}
			if (($l != '') && ($l[0] == '0')){
				$l = str_replace("\t",' ',$l);
				list($code,$uni,$rest) = explode(' ',$l);
				$tcode = hexdec($code);
				$tuni = hexdec($uni);
				$map[$tuni] = $tcode;
			}
		}

		$finalmap = array();
		if ($forceall){
			for($i=0;$i<256;$i++){
				$finalmap[$i] = $i;
			}
		}

		ksort($map);
		foreach($map as $tuni => $tcode){
			$finalmap[$tuni] = $tcode;
		}

		foreach($finalmap as $tuni => $tcode){
			$mapstr .= "\t$tuni\t=>\t$tcode,\t\t// 0x".dechex($tuni)." 0x".dechex($tcode)."\n";
		}
		
		
		
		$ret = "<?\n";
		$ret .= "\$this->map = array(\n";
		$ret .= $mapstr;
		$ret .= ");\n";
		$ret .="?>";
		return $ret;
	}
	

	function convertToEncoderClass($fn){
		global $srcDir;
		$canConvert = array();
		for($i=0;$i<256;$i++){
			$canConvert[$i] = false;
		}
		$forceall = false;
		$map = '';
		$lines = file($srcDir.'/'.$fn);
		foreach($lines as $l){
			$l = trim($l);
			if (strstr($l,'#CABORNFORCE') !== false){
				$forceall = true;
			}
			if (($l != '') && ($l[0] == '0')){
				$l = str_replace("\t",' ',$l);
				//print $l."<BR>\n";
				list($code,$uni,$rest) = explode(' ',$l);
				$tcode = hexdec($code);
				$tuni = hexdec($uni);
				$tunichar = unicode2utfsrc( $tuni);
				// >127 characters must be encode anyway
				if ($tcode != $tuni || $forceall){
					$canConvert[$tcode] = true;
					$map .= "\t$tcode\t=>\t$tunichar,\t\t// 0x$code 0x$uni\n";
					//$ret .= "\t$tcode\t=>\t$tuni,\t\t// 0x$code 0x$uni\n";
				}
			}
		}
		$ret = "<?\n";
		$ret .= "\$this->map = array(\n";
		$ret .= $map;
		$ret .= ");\n\n\n";
		$ret .= "\$this->differs = array(\n";
		//$canConvert[0] = false;
		for($i=0;$i<256;$i++){
			if ($canConvert[$i]){
				$ret .= "true,";
			}
			else{
				$ret .= "false,";
			}
			$ret .= "// 0x".dechex($i)."\n";
		}
		$ret .= ");\n";
		$ret .="?>";
		return $ret;
	}
	
	$srcDir = '../../lib/char/textmaps';
	$destEncoderDir = '../../lib/char/2utf8';
	$destDecoderDir = '../../lib/char/fromutf8';
	$filelist = array();
	
	if (is_dir($srcDir)) {
	    if ($dh = opendir($srcDir)) {
        	while (($file = readdir($dh)) !== false) {
        		if (is_file($srcDir .'/'. $file) && extractFileExtension(strtoupper($file)) =='TXT'){
        			$filelist[] = $file;
    	    	}
	        }
    		closedir($dh);
    	}
    }
    
    if (isset($_POST['convert']) && $_POST['convert'] == 'yes'){
    	foreach($filelist as $file){
    		$def = convertToEncoderClass($file);
    		$destFile = extractFileName($file).'.php';
    		$fh = fopen($destEncoderDir .'/'. $destFile,'w+');
    		if ($fh){
    			fwrite($fh,$def);
    			fclose($fh);
    			print "Written $destEncoderDir/$destFile<br>";
    		}

    		$def = convertToDecoderClass($file);
    		$destFile = extractFileName($file).'.php';
    		$fh = fopen($destDecoderDir .'/'. $destFile,'w+');
    		if ($fh){
    			fwrite($fh,$def);
    			fclose($fh);
    			print "Written $destDecoderDir/$destFile<br>";
    		}
    	}
    	print "DONE";
    }
    else{
    	print "Available textmaps:\n\n";
    	foreach($filelist as $f){
    		print "\t".$f."\n";
    	}
    	?>

    Are you sure you want to create the corresponding map classes from all of them?
<form method="post" action="index.php">
		<input type="submit" value="yes" name="convert">
</form>
    	<?
    }

    
?>


<a href="index.php">Restart</a>

<a href="../index.php">Utils</a>