// include the classes
#include "Cabron.as"
#include "CabronDebugger.as"

// clear the debugger panel
clearPrintr();

// set all the debugger options to true
setCabronDebugOption("showCallArguments",true);
setCabronDebugOption("outputErrors",false);
setCabronDebugOption("outputWarnings",false);
setCabronDebugOption("showResultData",true);
setCabronDebugOption("showMethodProfile",true);
setCabronDebugOption("showTimedDeser",true);
setCabronDebugOption("showPacketSize",true);

// create connector instance
_global.cc = new CabronConnector();
// set the location of the gateway
cc.setGatewayURL("http://localhost/cabronconnector/gateway");


// define the responder methods in this object
function getRandomArray_Result(res){
	trace("Response: array of length "+res.length);
}
function getRandomArray_Status(errMsg, errCode, shortErrMsg){
	trace("Error: "+errMsg);
}



// create service object with responder
var integerService = cc.getService("samples.profiledRandomIntegers",this);

// creating deserialization properties object
var dp = new CabronDeserProp();
// set the timed deserialization "T"
dp.deserMode = "T";
// set the other properties too
dp.tagAtOnce = 20;

// set the properties of the service
integerService.setDeserProp(dp);

// call the method of the service
integerService.getRandomArray(50);

