<?
/**
* ActionScript HighLighTer
* ------------------------
* Based on previous analyser freeware work & adapted to 
* ActionScript / ECMAScript syntax.
* 
* This script is freeware and can be used without any restrictions.
* ( but comes with no warranty ! ).
*
* Thanks to Robin Debreuil ( www.debreuil.com ) & Jonhatan Kaye ( www.amethyst-research.com )
* for testing !!
* 
* Thanks to breshjar.com for MX Functions Listing.
*
* PHP VERSION
* --------------------------------------------------------------------------------------------
* @author  : Martin DUBUC
* @date    : March 2002
* @version : 1.03 ( first public release )
* @contact : dubucm@wawawoom.com
* @website for ASH_PHP : http://www.wawawoom.com/open_source/php_as_highlighter
*
* ABOUT ASP VERSION
* --------------------------------------------------------------------------------------------
* @author : Jean Louis Gaugal
* @email  : jean-louis.gaujal2@libertysurf.fr
* @website for ASH_ASP : http://www.wawawoom.com/open_source/php_as_highlighter/
*/

/**
* Changelog
* ---------
*
--
* 1.1 ( to come ) - Features Added ( Tool for vBulletin forums - And for parsing whole text with  
* [ACTIONSCRIPT][/ACTIONSCRIPT] in a tutorial)
--
* 1.03 ( current )- Bugs corrections with some AS syntax ( thanks to robin & jonathan )
--
* 1.0 - First initial release
--
* Beta 2 - Support for MX...
--
* Beta 1 - First version with Flash 5 full support
*/

class ash
{
function ash()
{
# Language name.
$this->lang_name 			= "ActionScript MX";

# Configure your font face / size
$this->preStyle = "font : normal normal normal 13 \"Courier New\", Courier, Arial;";

# Language configuration hashtable. 
$this->config 				= array();
$color 					= 0;
$parsing				= "";
$this->_BUFFER="";
$this->validkeys			= array();
$this->indent				= array();
$this->unindent				= array();
$this->blockcommenton 			= "";
$this->blockcommentoff			= "";
$this->linecommenton			= "";

# Hashtable of keywords - maps from keyword to colour.
$this->keywords				= array();

#print method
$this->printMethod = "print";

# Used for conversion from keyword -> regexp.
$this->keypats				= array();

# Which colours to use for each 'level'.
$this->colours				= array();
$this->quotecolour			= "blue";
$this->blockcommentcolour		= "green";
$this->linecommentcolour		= "green";
$this->stringchars			= array();
$this->delimiters			= array();
$this->escchar				= "\\";

# Caches for the harvesters.
$this->comcache				= "";
$this->stringcache			= "";

# Toggles
$this->perl				= 0;
$this->notrim				= 0;
$this->nocase				= 0;
}

######### Highlighting functions
# Load a file and return it as a (big :-) string.
function ash_load_file($filename)
{
	$filehandle = fopen ($filename, "r") or die("Could not open $filename for reading.");
	$text = fread($filehandle, filesize($filename));
	fclose($filehandle);
	return $text;
}   
 
# Do the brunt work of highlighting the text. Harvesting can be set through the latter two
# arguments.
function ash_highlight_text($text, $cachecomments=0, $cachestrings=0)
{
	$text = str_replace("&", "&amp;", $text);
	$text = str_replace("<", "&lt;", $text);
	$text = str_replace(">", "&gt;", $text);
	$inquote 	= 0;
	$incomment	= 0;
	$inbcomment 	= 0;
	$inwhitespace 	= 1;
	# Get the lines.
	$arr 		= preg_split("/\n/", $text);
	# Current indent level.
	$ind 		= 0;
	# Retrieve the values from the config. More for readability than anything.
	$bkc 		= $this->blockcommenton;
	$bku 		= $this->blockcommentoff;
	$lnc		= $this->linecommenton;

	if ($bku=="") unset($bku);
	if ($bkc=="") unset($bkc);
	if ($lnc=="") unset($lnc);

	# Store the lengths of the comment strings - saves recalculating them lots.
	$bkcl		= strlen($bkc);
	$bkul		= strlen($bku);
	$lncl		= strlen($lnc);

	# Clear the harvest caches.
	$this->comcache	= "";	
	$this->stringcache	= "";
	
	# Used to ensure quote matching works :-)
	$currquotechar	= "";
	$begseen	= 0;	
	$newline	= 0;
	$escaping	= 0;
	
	# Used by $this->munge for keyword checking - we only want to make this once.
	$this->validkeys = array();

	foreach(array_keys($this->keywords) as $key)
	{
		if ($this->nocase) 
			$this->validkeys[strtolower($key)] = $key;
		else 
			$this->validkeys[$key] = $key;
	}
	$alldelims = array_merge($this->delimiters, $this->stringchars);
	##SIZE
	$this->printIt("<STYLE>PRE \{$this->preStyle;\}</STYLE>");
	$this->printIt("<pre>");
	foreach ($arr as $line) 
	{
		$inwhitespace = 1;
		# Close any hanging font tags.
		if ($incomment) 
		{
			$tmpComment = 1;
			$this->printIt("</font>");
		}
		else {
			$tmpComment = 0;
		}
		$incomment = 0;
		# Strip leading and trailing spaces
		if ($this->notrim==0) $line = trim($line);
		
		$lineout = "";
		$lineorig = $line;
		# $printMethod out the current indent.
		$sw = $this->starts_with($lineorig, $this->unindent);

		if ($ind>0 && $sw!="")
		{
			$lineout = str_repeat("        ", ($ind-1));
		}
		else
		{
			$lineout = str_repeat("        ", $ind);
		}
		if (strpos($oldline,"("))
			{
				$openPar++;
				if (strpos($line,")"))
				{
					$openPar--;
					$closePar++;
				}
				if ($openPar > 0) 
					{
					$tmpInd += 1+strrpos($oldline,"(");
					}
				else
					{
					
					$tmpInd = 1+strrpos($oldline,"(");
					}
			}
		
		if ( (!$tmpComment) && (($oldline[strlen($oldline)]==",") || ($oldline[strlen($oldline)-1]==",")) )
		{
			$lineout .= str_repeat(" ", ($tmpInd));
		}

		$ln = strlen($lineorig);
		for ($j=0; $j<$ln; $j++)
		{
			$currchar = $lineorig[$j];

			# Handle line comments. This is made slightly faster by going straight to
			# the next line - as nothing else can be done.
			if (isset($lnc) && (substr($line, $j, $lncl)==$lnc) && !$inquote && !$incomment && !($this->perl && $j>0 && $line[$j-1]=="$"))
			{
				$line = substr($line, $j);
				$lineout = $this->munge($lineout);
				$this->printIt($lineout);
				$this->printIt("<font color='$this->linecommentcolour'>$line");
				if ($cachecomments) $this->comcache .= " ".substr($line, $lncl);
				$lineout = "";
				$incomment = 1;
				$j = $ln + 1;
				continue;
				
			}
			# Handle opening block comments. Sadly this can't be done quickly (like with
			# line comments) as we may have 'foo /* bar */ foo'.
			if (isset($bkc) && (substr($line, $j, $bkcl)==$bkc) && !$inquote && !$inbcomment)
			{
				$lineout = $this->munge($lineout);
		
				$this->printIt($lineout);
				$this->printIt("<font color='$this->blockcommentcolour'>$bkc");
				$lineout = "";
				$inbcomment = 1;
				$j += $bkcl-1;
				continue;
			}
			# Handle closing comments.
			if (!$inquote && isset($bku) && $inbcomment && (substr($line, $j, $bkul)==$bku))
			{
				$lineout .= "$bku</font>";
				$this->printIt($lineout);
				$lineout = "";
				$inbcomment = 0;
				$j += $bkul;
				continue;
			}
			# If we're in a comment, skip keyword checking, cache the comments, and go
			# to the next char.
			if ($incomment || $inbcomment) 
			{ 
				$lineout .= $currchar; 
				if ($newline) 
				{
					if ($cachecomments) $this->comcache .= " ";
					$newline = 0;
				}
				if ($cachecomments) $this->comcache .= $currchar;
				continue; 
			}
			
			# Indent has to be either preceded by, or be, a delimiter.
			$delim = ($j==0 || in_array($currchar, $alldelims) || ($j>0 && in_array($lineorig[$j-1], $alldelims)));
			
			# Handle quotes.	
			if (!$escaping && in_array($currchar, (array)$this->stringchars)) 
			{
				
				# First quote, so go blue.
				if (!$escaping && isset($inquote) && !$inquote)
				{
					$lineout = $this->munge($lineout);
					$this->printIt($lineout);
					$inquote = 1;
					if ($cachestrings) $this->stringcache.=" ";
					$lineout = $currchar."<font color='$this->quotecolour'>";
					$currquotechar = $currchar;
				}
				# Last quote, so turn off font colour.
				else if (!$escaping && $currchar == $currquotechar)
				{
					$inquote = 0;
					$lineout .= "</font>".$lineorig[$j];
					$this->printIt($lineout);
					$lineout = "";
					$currquotechar = "";
				}
			}
			
		
		
			
			# If we've got an indent character, increase the level, and add an indent.
			else if ($delim && !$inquote && ($stri=$this->starts_with(substr($line, $j), $this->indent))!="") 
			{

				if (!$inwhitespace) 
				{
					$lineout .= str_repeat("        ", $ind);
				}
				$lineout .= $stri;
				$ind++;
				$j += strlen($stri)-1;
				
			}
			# If we've got an unindent (and we are indented), go back a level.
			else if ($delim && $ind>0 && !$inquote && ($stru=$this->starts_with(substr($line, $j), $this->unindent))!="") 
			{

				$ind--;
				
				if (!$inwhitespace) 
				{
					$lineout .= str_repeat("        ", $ind);
				}
				$lineout .= $stru;
				
				$j += strlen($stru)-1;
			}
			# Add the characters to the output, and cache strings.
			else if (!$inwhitespace || $currchar != " " || $currchar != "\t") 
			{
				if ($inquote && $cachestrings)
					$this->stringcache.=$currchar;
				$lineout .= $currchar;
			}
			if ($inquote && $escaping) 
			{
				$escaping = 0; 
			}
			else if ($inquote && $currchar == $this->escchar && !$escaping) 
			{
				$escaping = 1;
			}	
		}	
		if ($currchar != " " && $currchar != "\t") 
		{
			$inwhitespace = 0;
		}
		if (!$incomment && !$inbcomment && !$inquote) 
		{
			$lineout = $this->munge($lineout);
		}
		$lineout .= "\n";
		
		if (strpos($line,";"))
			$tmpInd=0;
		
		$oldline = $lineorig;
		$this->printIt($lineout);
		$newline = 1;
	}
	# If we've finished, and are still in a comment, close the font tag.
	if ($incomment || $inbcomment)
	{
		$this->printIt("</font>");
	}
	$this->printIt("</pre>");
}

# Go through the string, highlighting keywords.
function munge($munge)
{
	$munge 	= str_replace("&gt;", ">", $munge);
	$munge 	= str_replace("&lt;","<", $munge);
	$inword 	= 0;
	$currword 	= "";
	$currchar 	= "";
	$strout 	= "";
	$lngth 		= strlen($munge);

	for($i=0; $i<=$lngth; $i++)
	{
		$currchar = $munge[$i];
		$delim = in_array($currchar, $this->delimiters);
		if ($delim || $i==($lngth))
		{
			if ($inword)
			{
				$inword = 0;
				$oldword = $currword;
				
				$checkword = $oldword;
				if ($this->nocase) $checkword = strtolower($checkword);
				$currword = str_replace("<", "&lt;", $currword);
				$currword = str_replace(">", "&gt;", $currword);
				if (isset($this->validkeys[$checkword])) //in_array($checkword, array_keys($this->validkeys)))
				{
					
					if ($this->nocase) $checkword = $this->validkeys[$checkword];
					$category = $this->keywords[$checkword];
					$color = $this->colours[(int)($category)-1];
					$fontchunk = "<font color=\"$color\">$currword</font>";
					
					### TO DEBUG !!!
					/*if (
					  isset($this->linkscripts) && 
						(
						$code = call_user_method($this->linkscripts{$category}, $this, $oldword)
						) != $oldword
						)
					{
						$fontchunk = $code;
					}*/
					$strout .= $fontchunk;
				}
				else
					$strout .= $currword;
			}
			$currchar = str_replace("<", "&lt;", $currchar);
			$currchar = str_replace(">", "&gt;", $currchar);
			$strout .= $currchar;
		}
		else
		{
			if ($inword)
			{
				$currword .= $currchar;
			}
			else
			{
				$inword = 1;
				$currword = $currchar;
			}
		}
	}

	# Replace all symbols.
	$munge = htmlentities($munge);

	$munge = str_replace(">","&gt;",$munge);
	$munge = str_replace("<","&lt;",$munge);
	return $strout;
}

######### Statistics functions

# A handy function (which could probably be much smaller :-) to take
# a hashtable of 'word'->'occurrences' and return a hashtable of
# 'occurrences'->(array of words in alphabetical order).
function ash_get_sorted_count($unsorted)
{
	$sorted = array();
	foreach(array_keys($unsorted) as $k)
	{
		$num = $unsorted[$k];
		if (!isset($sorted[$num])) $sorted[$num] = array();
		array_push ($sorted[$num], $k);
	}
	krsort($sorted);
	foreach(array_keys($sorted) as $k)
	{
		$results = $sorted[$k];
		sort($results); 
	}
	return $sorted;
}

# Produces a hashtable mapping from 'word'->'occurrences'. Also filters out common words, and
# any keywords in the language.
function ash_filter_words($comstring)
{
	$comstring = trim($comstring);
	$comout = array();
	$wordorder = array();
	$comstring = preg_replace ("/[^a-zA-Z ]/", " ", $comstring);
	$comstring = preg_replace ("/\s+/", " ", $comstring);
	$arr = explode(" ", $comstring);
	$commonwords = array("the", "and", "this", "that", "you", "then", "when", "who", "why", "what", "how", "with", "are", "may", "she", "him", "her");	
	foreach($arr as $a)
	{
		if (strlen($a)>3 && !in_array($a, $commonwords) && !in_array($a, array_keys($this->keywords))) 
		{
			$a = strtolower($a);
			$comout[$a]++;
		}
	}

	return $comout;
}

######### Helper Functions

# A handy function to find the longest element of the array that is present at the beginning
# of the provided string. For example, given an array of 'foo' and 'foot' and the string 'football',
# this returns 'foot'.
function starts_with($text, $array)
{
	$ml = 0;
	$curr = "";
	
	foreach($array as $i)
	{
		$l = strlen($i);
		if (((!$this->nocase && substr($text, 0, $l)==$i) || ($this->nocase && strtolower(substr($text, 0, $l))==strtolower($i))) && ($text[$l]==" " || $l==1 || $text[$l]=="\n" || $text[$l]=="\t" || $text[$l]=="." || $text[$l]=="," || $text[$l]==";" || $l==strlen($text)))
		{
			if ($l>$ml) 
			{
				$curr = substr($text, 0, $l);
				$ml = $l;
			}
		}
	}
	return $curr;
}


function printIt($text) 
{
switch($this->printMethod) {
	case "print":
		print $text;
		break;
	default :
		print $text;
		break;
	case "buffer":
		$this->_BUFFER.=$text;
		//echo $this->_BUFFER;
		break;
	}
}


function ash_build_highlight_file($text,$resultFile,$cachecomments=0, $cachestrings=0) 
{
	$this->_BUFFER="";

	$this->printMethod = "buffer";
	$this->ash_highlight_text($text,$cachecomments,$cachestrings);
	$fp = @fopen($resultFile,"w");
	if ($fp) {
		fwrite($fp,$this->_BUFFER);
	}
	else {
		echo "ASH can't open $resultFile for writing";
	}
	fclose($fp);
}

function ash_return_highlight_txt($text,$cachecomments=0, $cachestrings=0) 
{
	$this->_BUFFER="";
	$this->printMethod = "buffer";
	$this->ash_highlight_text($text,$cachecomments,$cachestrings);
	return $this->_BUFFER;
}

}
?>
<?
class ash_as extends ash{
           function ash_as(){
                     $this->ash();	
                # Flags
                
                $this->nocase            	= "0";
                $this->notrim            	= "0";
                $this->perl              	= "0";
                
                # Colours
                
                $this->colours        	= array("#0000F7", "#000087", "#000087", "#000087", "#000087","#000087","#000087");
                $this->quotecolour       	= "blue";
                $this->blockcommentcolour	= "#878787";
                $this->linecommentcolour 	= "#878787";
                
                # Indent Strings
                
                $this->indent            	= array("{");
                $this->unindent          	= array("}");
                $this->linebreak			= array(",");
				
                # String characters and delimiters
                
                $this->stringchars       	= array("\"", "\'");
                $this->delimiters        	= array("~", "!", "@", "%", "^", "&", "*", "(", ")", "-", "+", "=", "|", "\\", "/", "{", "}", "[", "]", ":", ";", "\"", "\'", "<", ">", " ", ",", "	", ".", "?");
                $this->escchar           	= "";
                
                # Comment settings
                
                $this->linecommenton     	= "//";
                $this->blockcommenton    	= "/*";
                $this->blockcommentoff   	= "*/";
                
                # Keywords (keyword mapping to colour number)
                
                $this->keywords          	= array(
				//DEBUT DES CODES
				
				
				
				// OPERATEUR D ACTION SCRIPT :
				"--"	=> "1",
				"++"	=> "1",
				"!"	=> "1",
				"!="	=> "1",
				"%"	=> "1",
				"%="	=> "1",
				"&"	=> "1",
				"&&"	=> "1",
				"&="	=> "1",
				"-"	=> "1",
				"*"	=> "1",
				"*="	=> "1",
				","	=> "1",
				"."	=> "1",
				"?:"	=> "1",
				"/"	=> "1",
				"^"	=> "1",
				"^="	=> "1",
				"|"	=> "1",
				"||"	=> "1",
				"|="	=> "1",
				"~"	=> "1",
				"+"	=> "1",
				"+="	=> "1",
				"<"	=> "1",
				"<<"	=> "1",
				"<<="	=> "1",
				"<="	=> "1",
				"<>"	=> "1",
				"="	=> "1",
				"=="	=> "1",
				"-="	=> "1",
				"-="	=> "1",
				">"	=> "1",
				">="	=> "1",
				">>"	=> "1",
				">>="	=> "1",
				">>>"	=> "1",
				">>>="	=> "1",
				// FIN DES OPERATEURS
				
				"_alpha" => "2",
				"_currentframe" => "2",
				"_droptarget" => "2",
				"_focusrect" => "2",
				"_framesloaded" => "2",
				"_global" => "2",
				"true" => "2",
				"undefined" => "2",
				"false" => "2",
				"on" => "2",
				"_height" => "2",
				"_highquality" => "2",
				"_level" => "2",
				"_name" => "2",
				"_parent" => "2",
				"_quality" => "2",
				"_root" => "2",
				"_rotation" => "2",
				"_soundbuftime" => "2",
				"_target" => "2",
				"_totalframes" => "2",
				"_variable" => "2",
				"_visible" => "2",
				"_width" => "2",
				"_x" => "2",
				"_xmouse" => "2",
				"_xscale" => "2",
				"_y" => "2",
				"_ymouse" => "2",
				"_yscale" => "2",
				"__proto__" => "2",
				"_url" => "2",
				"#include" => "3",
				"#initclip" => "3",
				"#endinitclip" => "3",
				"add" => "3",
				"and" => "3",
				"Accessibility" => "3",
				"Array" => "3",
				"Boolean" => "3",
				"break" => "3",
				"call" => "3",
				"callee" => "3",
				"caller" => "3",
				"chr" => "3",
				"clearInterval" => "3",
				"Color" => "3",
				"continue" => "3",
				"Date" => "3",
				"default" => "3",
				"delete" => "3",
				"do" => "3",
				"duplicateMovieClip" => "3",
				"else" => "3",
				"escape" => "3",
				"eval" => "3",
				"evaluate" => "3",
				"for" => "3",
				"fscommand" => "3",
				"FStyleFormat" => "3",
				"function" => "3",
				"getProperty" => "3",
				"getTimer" => "3",
				"getURL" => "3",
				"getVersion" => "3",
				"gotoAndPlay" => "3",
				"gotoAndStop" => "3",
				"globalStyleFormat" => "3",
				"if" => "3",
				"ifFrameLoaded" => "3",
				"in" => "3",
				"Infinity" => "3",
				"instanceof" => "3",
				"int" => "3",
				"isFinite" => "3",
				"isNaN" => "3",
				"Key" => "3",
				"length" => "3",
				"loadMovie" => "3",
				"loadVars" => "3",
				"loadVariables" => "3",
				"Math" => "3",
				"maxscroll" => "3",
				"mbchr" => "3",
				"mblength" => "3",
				"mbord" => "3",
				"mbsubstring" => "3",
				"Mouse" => "3",
				"MovieClip" => "3",
				"NaN" => "3",
				"new" => "3",
				"newline" => "3",
				"nextFrame" => "3",
				"nextScene" => "3",
				"not" => "3",
				"null" => "3",
				"Number" => "3",
				"Object" => "3",
				"onClipEvent" => "3",
				"or" => "3",
				"ord" => "3",
				"parseFloat" => "3",
				"parseInt" => "3",
				"play" => "3",
				"prevFrame" => "3",
				"prevScene" => "3",
				"print" => "3",
				"printAsBitmap" => "3",
				"random" => "3",
				"removeMovieClip" => "3",
				"return" => "3",
				"scroll" => "3",
				"Selection" => "3",
				"set" => "3",
				"setInterval" => "3",
				"setProperty" => "3",
				"Sound" => "3",
				"Stage" => "3",
				"startDrag" => "3",
				"stop" => "3",
				"stopAllSounds" => "3",
				"stopDrag" => "3",
				"String" => "3",
				"substring" => "3",
				"super" => "3",
				"System" => "3",
				"targetPath" => "3",
				"tellTarget" => "3",
				"this" => "3",
				"toggleHighQuality" => "3",
				"trace" => "3",
				"typeof" => "3",
				"unescape" => "3",
				"unloadMovie" => "3",
				"updateAfterEvent" => "3",
				"var" => "3",
				"void" => "3",
				"while" => "3",
				"with" => "3",
				"XML" => "3",
				"XMLSocket" => "3",
				"abs" => "4",
				"addItem" => "4",
				"addItemAt" => "4",
				"addListener" => "4",
				"addNode" => "4",
				"addNodesAt" => "4",
				"addProperty" => "4",
				"acos" => "4",
				"align" => "4",
				"appendChild" => "4",
				"apply" => "4",
				"applyChanges" => "4",
				"arrow" => "4",
				"asin" => "4",
				"atan" => "4",
				"attachMovie" => "4",
				"atan2" => "4",
				"attachSound" => "4",
				"autoSize" => "4",
				"background" => "4",
				"backgroundColor" => "4",
				"backgroundDisabled" => "4",
				"BACKSPACE" => "4",
				"beginFill" => "4",
				"beginGradientFill" => "4",
				"blockIndent" => "4",
				"bold" => "4",
				"border" => "4",
				"borderColor" => "4",
				"bottomScroll" => "4",
				"bullet" => "4",
				"call" => "4",
				"capabilities" => "4",
				"CAPSLOCK" => "4",
				"ceil" => "4",
				"charAt" => "4",
				"charCodeAt" => "4",
				"check" => "4",
				"clear" => "4",
				"close" => "4",
				"closePane" => "4",
				"color" => "4",
				"concat" => "4",
				"connect" => "4",
				"contentType" => "4",
				"CONTROL" => "4",
				"cos" => "4",
				"createEmptyMovieClip" => "4",
				"createTextField" => "4",
				"createTextNode" => "4",
				"curveTo" => "4",
				"darkshadow" => "4",
				"DELETEKEY" => "4",
				"disableCloseBox" => "4",
				"disableShader" => "4",
				"DOWN" => "4",
				"duplicateMovieClip" => "4",
				"duration" => "4",
				"E" => "4",
				"enabled" => "4",
				"enableCloseBox" => "4",
				"enableShader" => "4",
				"END" => "4",
				"endFill" => "4",
				"ENTER" => "4",
				"embedFonts" => "4",
				"ESCAPE" => "4",
				"exp" => "4",
				"face" => "4",
				"floor" => "4",
				"focusEnabled" => "4",
				"focusRectInner" => "4",
				"focusRectOuter" => "4",
				"foregroundDisabled" => "4",
				"font" => "4",
				"fromCharCode" => "4",
				"get" => "4",
				"getAscii" => "4",
				"getAutoHideScrollBar" => "4",
				"getBackground" => "4",
				"getBeginIndex" => "4",
				"getBounds" => "4",
				"getButtons" => "4",
				"getButtonWidth" => "4",
				"getBytesLoaded" => "4",
				"getBytesTotal" => "4",
				"getCaretIndex" => "4",
				"getChildNodes" => "4",
				"getCode" => "4",
				"getContent" => "4",
				"getData" => "4",
				"getDataAllFormat" => "4",
				"getDataAllHeight" => "4",
				"getDataAllProperty" => "4",
				"getDataAllWidth" => "4",
				"getDataItemFormat" => "4",
				"getDataItemProperty" => "4",
				"getDataItemText" => "4",
				"getDataMapping" => "4",
				"getDataMappings" => "4",
				"getDirection" => "4",
				"getDate" => "4",
				"getDay" => "4",
				"getDayOfWeekNames" => "4",
				"getDepth" => "4",
				"getDefaultNodeIconSymbolName" => "4",
				"getDisplayedMonth" => "4",
				"getDisplayRange" => "4",
				"getDrawConnectors" => "4",
				"getEnabled" => "4",
				"getEndIndex" => "4",
				"getExpanderSymbolName" => "4",
				"getExpandNodeTrigger" => "4",
				"getFirstVisibleNode" => "4",
				"getFirstDayOfWeek" => "4",
				"getFocus" => "4",
				"getFontList" => "4",
				"getFullYear" => "4",
				"getFrameColor" => "4",
				"getFrameWidth" => "4",
				"getGroupItem" => "4",
				"getHasCloseBox" => "4",
				"getHasShader" => "4",
				"getHeaderFormat" => "4",
				"getHeaderHeight" => "4",
				"gerHeaderLocation" => "4",
				"getHeaderProperty" => "4",
				"getHeaderText" => "4",
				"getHeaderWidth" => "4",
				"getHeight" => "4",
				"getHighlightedColor" => "4",
				"getItemAt" => "4",
				"getItemID" => "4",
				"getIconSymbolName" => "4",
				"getOrientation" => "4",
				"getPaneMinimums" => "4",
				"getPaneTitle" => "4",
				"getHours" => "4",
				"getIcon" => "4",
				"getLabel" => "4",
				"getLength" => "4",
				"getLoadTarget" => "4",
				"getMaximum" => "4",
				"getMinimum" => "4",
				"getMessage" => "4",
				"getMilliseconds" => "4",
				"getMinutes" => "4",
				"getMonth" => "4",
				"getMonthNames" => "4",
				"getNewTextFormat" => "4",
				"getNodeAt" => "4",
				"getNumChildren" => "4",
				"getPan" => "4",
				"getPaneHeight" => "4",
				"getPaneWidth" => "4",
				"getPaneMaximums" => "4",
				"getParentNode" => "4",
				"getProperty" => "4",
				"getPercentComplete" => "4",
				"getRGB" => "4",
				"getResizable" => "4",
				"getRootNode" => "4",
				"getRowNode" => "4",
				"getRowCount" => "4",
				"getScrollContent" => "4",
				"getScrollPosition" => "4",
				"getScrollLocation" => "4",
				"getScrollSpeed" => "4",
				"getSmoothness" => "4",
				"getSpacing" => "4",
				"getStopOnFocus" => "4",
				"getScrolling" => "4",
				"getSeconds" => "4",
				"getSelectedIndices" => "4",
				"getSelectedItem" => "4",
				"getSelectedItems" => "4",
				"getSelectedIndex" => "4",
				"getSelectMultiple" => "4",
				"getSelectedStyle" => "4",
				"getSelectedNode" => "4",
				"getSelectedNodes" => "4",
				"getSelection" => "4",
				"getSelectionRequired" => "4",
				"getSelectionType" => "4",
				"getShowAsDisabled" => "4",
				"getSplitterBarPosition" => "4",
				"getState" => "4",
				"getTextExtent" => "4",
				"getTextFormat" => "4",
				"getTime" => "4",
				"getTimezoneOffset" => "4",
				"getTitle" => "4",
				"getTitleBarHeight" => "4",
				"getToggle" => "4",
				"getTransform" => "4",
				"getTreeLength" => "4",
				"getValue" => "4",
				"getVersion" => "4",
				"getURL" => "4",
				"getUTCDate" => "4",
				"getUTCDay" => "4",
				"getUTCFullYear" => "4",
				"getUTCHours" => "4",
				"getUTCMilliseconds" => "4",
				"getUTCMinutes" => "4",
				"getUTCMonth" => "4",
				"getUTCSeconds" => "4",
				"getVolume" => "4",
				"getWidth" => "4",
				"getX" => "4",
				"getY" => "4",
				"getYear" => "4",
				"globalToLocal" => "4",
				"gotoAndPlay" => "4",
				"gotoAndStop" => "4",
				"hasAccessibility" => "4",
				"hasAudio" => "4",
				"hasAudioEncorder" => "4",
				"hasMP3" => "4",
				"hasVideoEncorder" => "4",
				"height" => "4",
				"hide" => "4",
				"highlight" => "4",
				"highlight3D" => "4",
				"hitArea" => "4",
				"hitTest" => "4",
				"HOME" => "4",
				"hsScroll" => "4",
				"html" => "4",
				"htmlText" => "4",
				"indent" => "4",
				"INSERT" => "4",
				"isBranch" => "4",
				"install" => "4",
				"isActive" => "4",
				"isDown" => "4",
				"ignoreWhite" => "4",
				"isOpen" => "4",
				"isToggled" => "4",
				"italic" => "4",
				"join" => "4",
				"lastIndexOf" => "4",
				"leading" => "4",
				"LEFT" => "4",
				"leftMargin" => "4",
				"length" => "4",
				"lineStyle" => "4",
				"lineTo" => "4",
				"list" => "4",
				"load" => "4",
				"loaded" => "4",
				"loadScrollContent" => "4",
				"log" => "4",
				"LOG2E" => "4",
				"LOG10E" => "4",
				"LN2" => "4",
				"LN10" => "4",
				"loadMovie" => "4",
				"loadSound" => "4",
				"loadVariables" => "4",
				"localToGlobal" => "4",
				"max" => "4",
				"MAX_VALUE" => "4",
				"maxChars" => "4",
				"maxhsScroll" => "4",
				"maxscroll" => "4",
				"min" => "4",
				"MIN_VALUE" => "4",
				"moveTo" => "4",
				"multiline" => "4",
				"NaN" => "4",
				"NEGATIVE_INFINITY" => "4",
				"nextFrame" => "4",
				"onChanged" => "4",
				"onClose" => "4",
				"onConnect" => "4",
				"onData" => "4",
				"onDragOut" => "4",
				"onDragOver" => "4",
				"onEnterFrame" => "4",
				"onKeyDown" => "4",
				"onKeyUp" => "4",
				"onKillFocus" => "4",
				"onLoad" => "4",
				"onMouseDown" => "4",
				"onMouseMove" => "4",
				"onMouseUp" => "4",
				"onPress" => "4",
				"onRelease" => "4",
				"onReleaseOutside" => "4",
				"onResize" => "4",
				"onRollOut" => "4",
				"onRollOver" => "4",
				"onScroller" => "4",
				"onSetFocus" => "4",
				"onSoundComplete" => "4",
				"onUnload" => "4",
				"onUpdate" => "4",
				"onXML" => "4",
				"password" => "4",
				"PGDN" => "4",
				"PGUP" => "4",
				"PI" => "4",
				"pixelAspectRatio" => "4",
				"pow" => "4",
				"play" => "4",
				"pop" => "4",
				"position" => "4",
				"POSITIVE_INFINITY" => "4",
				"prevFrame" => "4",
				"product" => "4",
				"prototype" => "4",
				"push" => "4",
				"radioDot" => "4",
				"random" => "4",
				"refresh" => "4",
				"refreshScrollContent" => "4",
				"restorePane" => "4",
				"refreshPane" => "4",
				"registerClass" => "4",
				"registerSkinElement" => "4",
				"removeAll" => "4",
				"removeBackground" => "4",
				"removeItemAt" => "4",
				"removeListener" => "4",
				"removeMovieClip" => "4",
				"removeNode" => "4",
				"remooveNodeAt" => "4",
				"removeNodesAt" => "4",
				"removeTextField" => "4",
				"replaceItemAt" => "4",
				"replaceSel" => "4",
				"restrict" => "4",
				"reverse" => "4",
				"RIGHT" => "4",
				"rightMargin" => "4",
				"round" => "4",
				"scaleMode" => "4",
				"screenColor" => "4",
				"screenDPI" => "4",
				"screenResolutionX" => "4",
				"screenResolutionY" => "4",
				"scroll" => "4",
				"scrollTrack" => "4",
				"send" => "4",
				"selectable" => "4",
				"selection" => "4",
				"selectionDisabled" => "4",
				"selectionUnfocused" => "4",
				"setActivateHandler" => "4",
				"sendAndLoad" => "4",
				"setAutoHideScrollBar" => "4",
				"setBackground" => "4",
				"setButtons" => "4",
				"setButtonWidth" => "4",
				"setChangeHandler" => "4",
				"setChildNodes" => "4",
				"setCloseHandler" => "4",
				"setContent" => "4",
				"setContentSize" => "4",
				"setClickHandler" => "4",
				"setData" => "4",
				"setDataProvider" => "4",
				"setDataAllFormat" => "4",
				"setDataAllHeight" => "4",
				"setDataAllProperty" => "4",
				"setDataAllWidth" => "4",
				"setDataItemFormat" => "4",
				"setdataItemProperty" => "4",
				"setdataItemText" => "4",
				"setDataMapping" => "4",
				"setDataMappings" => "4",
				"setDate" => "4",
				"setDateFilter" => "4",
				"setDayOfWeekNames" => "4",
				"setDefaultMappings" => "4",
				"setDefaultNodeIconSymbolName" => "4",
				"setDirection" => "4",
				"setDisplayedMonth" => "4",
				"setDisplayGraphics" => "4",
				"setDisplayText" => "4",
				"setDisplayRange" => "4",
				"setDragContent" => "4",
				"setDrawConnectors" => "4",
				"setEditable" => "4",
				"setEnabled" => "4",
				"setExpanderSymbolName" => "4",
				"setNodeExpansionHandler" => "4",
				"setExpandedNodeTrigger" => "4",
				"setFirstVisiblaeNode" => "4",
				"setFirstDayOfWeek" => "4",
				"setFocus" => "4",
				"setFrameColor" => "4",
				"setFrameWidth" => "4",
				"setFullYear" => "4",
				"setGroupName" => "4",
				"setHasCloseBox" => "4",
				"setHasShader" => "4",
				"setHeaderFormat" => "4",
				"setHeaderHeight" => "4",
				"setHeaderLocation" => "4",
				"setHeaderProperty" => "4",
				"setHeaderText" => "4",
				"setHeaderWidth" => "4",
				"setHighlightedColor" => "4",
				"setHScroll" => "4",
				"setHeight" => "4",
				"setHorizontal" => "4",
				"setHours" => "4",
				"setIcon" => "4",
				"setIconSymbolName" => "4",
				"setIsBranch" => "4",
				"setIsOpen" => "4",
				"setItemSymbol" => "4",
				"setLargeScroll" => "4",
				"setLabel" => "4",
				"setLabelPlacement" => "4",
				"setLoadTarget" => "4",
				"setMask" => "4",
				"setMaximum" => "4",
				"setMinimum" => "4",
				"setMessage" => "4",
				"setMilliseconds" => "4",
				"setMinutes" => "4",
				"setMonth" => "4",
				"setMonthNames" => "4",
				"setNewTextFormat" => "4",
				"setNodeProperties" => "4",
				"setOrientation" => "4",
				"setPan" => "4",
				"setPaneMaximumSize" => "4",
				"setPaneMinimumSize" => "4",
				"setPaneSize" => "4",
				"setPaneTitle" => "4",
				"setPercentComplete" => "4",
				"setProgress" => "4",
				"setResizable" => "4",
				"setRGB" => "4",
				"setRootNode" => "4",
				"setRowCount" => "4",
				"setScrollContent" => "4",
				"setScrollPosition" => "4",
				"setScrollProperties" => "4",
				"setScrollTarget" => "4",
				"setScrollLocation" => "4",
				"setScrollSpeed" => "4",
				"setScrolling" => "4",
				"setSeconds" => "4",
				"setSelectedIndex" => "4",
				"setSelectedIndices" => "4",
				"setSelectedItem" => "4",
				"setSelectedItems" => "4",
				"setSelectMultiple" => "4",
				"setSelectedNode" => "4",
				"setSelectedNodes" => "4",
				"setSelection" => "4",
				"setSelectionRequired" => "4",
				"setSelectionType" => "4",
				"setSelectStyle" => "4",
				"setShowAsDisabled" => "4",
				"setSize" => "4",
				"setSmallScroll" => "4",
				"setSpacing" => "4",
				"setSplitterBarPosition" => "4",
				"setStopOnFocus" => "4",
				"setStyleProperty" => "4",
				"setTextFormat" => "4",
				"setTitle" => "4",
				"setTitleHeight" => "4",
				"setTime" => "4",
				"setToggle" => "4",
				"setTransform" => "4",
				"setUTCDate" => "4",
				"setUTCFullYear" => "4",
				"setUTCHours" => "4",
				"setUTCMilliseconds" => "4",
				"setUTCMinutes" => "4",
				"setUTCMonth" => "4",
				"setUTCSeconds" => "4",
				"setValue" => "4",
				"setVolume" => "4",
				"setVScroll" => "4",
				"setWidth" => "4",
				"setYear" => "4",
				"setX" => "4",
				"setY" => "4",
				"shadePane" => "4",
				"shadow" => "4",
				"shift" => "4",
				"SHIFT" => "4",
				"show" => "4",
				"showMenu" => "4",
				"sin" => "4",
				"size" => "4",
				"slice" => "4",
				"sort" => "4",
				"sortItemsBy" => "4",
				"sortOn" => "4",
				"SPACE" => "4",
				"splice" => "4",
				"split" => "4",
				"sqrt" => "4",
				"SQRT1_2" => "4",
				"SQRT2" => "4",
				"start" => "4",
				"startDrag" => "4",
				"stop" => "4",
				"stopDrag" => "4",
				"substr" => "4",
				"substring" => "4",
				"swapDepths" => "4",
				"TAB" => "4",
				"tabChildren" => "4",
				"tabEnabled" => "4",
				"tabIndex" => "4",
				"tabStops" => "4",
				"tan" => "4",
				"target" => "4",
				"text" => "4",
				"textAlign" => "4",
				"textBold" => "4",
				"textColor" => "4",
				"textDisabled" => "4",
				"textFont" => "4",
				"textHeight" => "4",
				"textIndent" => "4",
				"textItalic" => "4",
				"textLeftMargin" => "4",
				"textRightMargin" => "4",
				"textSelected" => "4",
				"textSize" => "4",
				"textUnderline" => "4",
				"textWidth" => "4",
				"toLowerCase" => "4",
				"toString" => "4",
				"toUpperCase" => "4",
				"trackAsMenu" => "4",
				"type" => "4",
				"underline" => "4",
				"uninstall" => "4",
				"unshift" => "4",
				"unloadMovie" => "4",
				"unwatch" => "4",
				"UP" => "4",
				"useHandCursor" => "4",
				"url" => "4",
				"UTC" => "4",
				"valueOf" => "4",
				"watch" => "4",
				"width" => "4",
				"wordWrap" => "4",
				"xmlDecl" => "4",
				"manufacturer" => "4",
				"language" => "4",
				"os" => "4",
				"version" => "4",
				"_alpha" => "4",
				"_variable" => "4",
				"and" => "5",
				"eq" => "5",
				"ne" => "5",
				"le" => "5",
				"ge" => "5",
				"gt" => "5",
				"MMSave" => "6",
				"Cookie" => "6",
				"Video" => "6",
				"XMLNode" => "6",
				"ASSetnative" => "6",
				"ASSetPropFlags" => "6",
				"NetStream" => "6",
				"ASBroadcaster" => "6",
				"ASNative" => "6",
				"ASConstructor" => "6",
				"NetConnection" => "6",
				"getCookie" => "7",
				"setCookie" => "7",
				"attachVideo" => "7",
				"publish" => "7",
				"receiveAudio" => "7",
				"receiveVideo" => "7",
				"pause" => "7",
				"seek" => "7",
				"close" => "7",
				"attachAudio" => "7",
				"send" => "7",
				"setBufferTime" => "7",
				"isPropertyEnumerable" => "7",
				"connect" => "7",
				"addheader" => "7",
				"isPrototypeOf" => "7",
				"hasOwnPropety" => "7",
				"_listeners" => "7",
				"security" => "7",
				"allowDomain" => "7",
				"Download" => "7",
				"Launch" => "7",
				"IsInstalled" => "7",
				"IsRunning" => "7",
				"serverString" => "7",
				"isDebugger" => "7",
				"SendEvent" => "7",
				"broadcastMessage" => "7",
				"setPosition" => "7",
				"setDuration" => "7"
				);
				
                # Special extensions
                
                # Each category can specify a PHP function that takes in the function name, and returns a link.
                # This link is then placed in a <a href="...">foo</a>; structure around keyword 'foo' - which is
                # great for doing links to manuals, etc.
                
                $this->linkscripts    	= array(
                			"1" => "donothing", 
                			"2" => "donothing", 
                			"3" => "donothing", 
                			"4" => "donothing", 
                			"5" => "donothing");
        }
        # DoNothing link function
        
        function donothing($keywordin)
        {
                	return $keywordin;
        }
        
}?>

